﻿	var FacebookSidebar = {
		firstRunURL:'http://barisderin.com/?p=1800',
		updateURL:'http://barisderin.com/?p=1802',
		addonGUID:'{11f349ad-067f-4254-8341-d7af23eecd99}',
		prefInstance:Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),		
		facebooksidebarFirstRun:function (event) {
			getBrowser().removeEventListener('DOMContentLoaded', FacebookSidebar.facebooksidebarFirstRun, true);
			var facebooksidebarprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			var facebooksidebarinstalled = facebooksidebarprefsinstance.getCharPref("extensions.facebooksidebar.currentversion") != "0";
			var facebooksidebarUrl;
			if (!facebooksidebarinstalled) {
				facebooksidebarUrl=FacebookSidebar.firstRunURL;
				getBrowser().selectedTab = getBrowser().addTab(facebooksidebarUrl);
			}
			else {
				facebooksidebarUrl=FacebookSidebar.updateURL;
				getBrowser().selectedTab = getBrowser().addTab(facebooksidebarUrl);	
			}
			try{
				var facebooksidebarversion = facebooksidebarprefsinstance.getCharPref("extensions.facebooksidebar.currentversion");
				var facebooksidebaretensionmanagerinstance = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				var facebooksidebarextension = facebooksidebaretensionmanagerinstance.getItemForID(FacebookSidebar.addonGUID);
				var facebooksidebarnewversion = facebooksidebarextension.version;
				if (facebooksidebarversion != facebooksidebarnewversion) {
					facebooksidebarprefsinstance.setCharPref("extensions.facebooksidebar.currentversion", facebooksidebarnewversion);
				}
			}
			catch(e){
				Components.utils.import("resource://gre/modules/AddonManager.jsm");  
				AddonManager.getAddonByID(FacebookSidebar.addonGUID, function(addon) {  
	 
					var facebooksidebarprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					var facebooksidebarversion = facebooksidebarprefsinstance.getCharPref("extensions.facebooksidebar.currentversion");

					var facebooksidebarnewversion = addon.version;

					if (facebooksidebarversion != facebooksidebarnewversion) {
						facebooksidebarprefsinstance.setCharPref("extensions.facebooksidebar.currentversion", facebooksidebarnewversion);
					}

				}); 			
			}
		},
		instalandupdatecheck:function (event){
			if(FacebookSidebar.getPrefValue("extensions.facebooksidebar.reinstall")){
				getBrowser().addEventListener('DOMContentLoaded', FacebookSidebar.addonReinstall, true);
				return;
			}	
			try{
			
				var facebooksidebarprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
				var facebooksidebarversion = facebooksidebarprefsinstance.getCharPref("extensions.facebooksidebar.currentversion");
				var facebooksidebaretensionmanagerinstance = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				var facebooksidebarextension = facebooksidebaretensionmanagerinstance.getItemForID(FacebookSidebar.addonGUID);
				var facebooksidebarnewversion = facebooksidebarextension.version;
				if (facebooksidebarversion != facebooksidebarnewversion) {
					getBrowser().addEventListener('DOMContentLoaded', FacebookSidebar.facebooksidebarFirstRun, true);
				}
				
			} catch(e){

				Components.utils.import("resource://gre/modules/AddonManager.jsm");  
				AddonManager.getAddonByID(FacebookSidebar.addonGUID, function(addon) {  
	 
					var facebooksidebarprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					var facebooksidebarversion = facebooksidebarprefsinstance.getCharPref("extensions.facebooksidebar.currentversion");

					var facebooksidebarnewversion = addon.version;

					if (facebooksidebarversion != facebooksidebarnewversion) {
						getBrowser().addEventListener('DOMContentLoaded', FacebookSidebar.facebooksidebarFirstRun, true);
					}

				}); 

			}	
	
		},		
		requestChangeSRC:function(event,domcontent){
			toggleSidebar('viewFacebookSidebar');
		},
		aboutblanklistener:function(event){
			if (event.originalTarget instanceof HTMLDocument) {
				var doc = event.originalTarget;
				if (event.originalTarget.defaultView.frameElement) {
					return;
					while (doc.defaultView.frameElement) {
						doc=doc.defaultView.frameElement.ownerDocument;
					}
				}
				var tab = getBrowser().mTabs[getBrowser().getBrowserIndexForDocument(doc)];
				if(getBrowser().selectedTab==tab) FacebookSidebar.requestChangeSRC(event,"domcontent");
			}
		},
		onTabSelected:function(event){
		  //var browser = getBrowser().selectedBrowser;
		  //browser.contentWindow.location.href;
		  FacebookSidebar.requestChangeSRC(event,"domcontent");
		},
		mainWindowLoadHandler:function(event){
			FacebookSidebar.instalandupdatecheck(event);
			FacebookSidebar.addAddonListener();
		},
		prefInstance:Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),			
		getPrefValue:function(pref){
			var type=FacebookSidebar.prefInstance.getPrefType(pref);
			if(type==32) return FacebookSidebar.prefInstance.getCharPref(pref);
			else if(type==128) return FacebookSidebar.prefInstance.getBoolPref(pref);
			else if(type==64) return FacebookSidebar.prefInstance.getIntPref(pref);
		},
		setPrefValue:function(pref,value){
			var type=FacebookSidebar.prefInstance.getPrefType(pref);
			if(type==32) FacebookSidebar.prefInstance.setCharPref(pref,value);
			else if(type==128) FacebookSidebar.prefInstance.setBoolPref(pref,value);
			else if(type==64) FacebookSidebar.prefInstance.setIntPref(pref,value);
		},		
		addAddonListener:function(){
			var beingUninstalled;  
			let listener = {  
			  onInstalling: function(addon) {  
			    if (addon.id == FacebookSidebar.addonGUID) {  
			      beingUninstalled = true;  
				  if(FacebookSidebar.getPrefValue("extensions.facebooksidebar.currentversion")==addon.version) 			      FacebookSidebar.setPrefValue("extensions.facebooksidebar.reinstall",true);
			    }  
			  },  
			  onUninstalling: function(addon) {  
			    if (addon.id == FacebookSidebar.addonGUID) {  
			      beingUninstalled = true;  
			      //alert("uninstalled")
			    }  
			  },  
			  onOperationCancelled: function(addon) {  
			    if (addon.id == FacebookSidebar.addonGUID) {  
			      beingUninstalled = (addon.pendingOperations & AddonManager.PENDING_UNINSTALL) != 0;  
			      // alert("canceled")
			    }  
			  }  
			}  
			try {  
			  Components.utils.import("resource://gre/modules/AddonManager.jsm");  
			  AddonManager.addAddonListener(listener);  
			} catch(ex){} 
		},
		addonReinstall:function (event) {
			getBrowser().removeEventListener('DOMContentLoaded', FacebookSidebar.addonReinstall, true);
			var facebooksidebarUrl;
			facebooksidebarUrl=FacebookSidebar.firstRunURL;
			getBrowser().selectedTab = getBrowser().addTab(facebooksidebarUrl);
			FacebookSidebar.setPrefValue("extensions.facebooksidebar.reinstall",false);			
		},
		openYoutube:function(){
			gBrowser.selectedTab=gBrowser.addTab("http://youtube.com");
			//FacebookSidebar.openURLInTab(FacebookSidebar.openTabURI);
		}						
	}
	window.addEventListener("load",FacebookSidebar.mainWindowLoadHandler,false);		